//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
        
	using System.IO.Ports;   
	
    public partial class SerialComScript
	{
		public static SerialCom serialCom = null;
		
		static SerialComScript() 
		{
			serialCom = new SerialCom();
		}
		
		public void Send(string data)
		{
			serialCom.SendData(data);
		}

		public static void Dbg(string data)
		{
			Globals.Tags.Tag1.Value = Globals.Tags.Tag1.Value + data;	
		}
    }
	
	public class SerialCom
	{
		public SerialPort sPort = null;
		
		private Timer myTimer = new Timer();
		
		public SerialCom()
		{
			sPort = new SerialPort("COM3", 9600, Parity.None, 8, StopBits.One);
			sPort.Open();
			
			myTimer.Tick += new EventHandler(TimerEventProcessor);
			myTimer.Interval = 100;
			myTimer.Enabled = true;
		}

		public void SendData(string outData) {
			sPort.Write(outData);
		}
		
		private void TimerEventProcessor(Object myObject, EventArgs myEventArgs) 
		{			
			string tmp = "";
			
			try {
				tmp = sPort.ReadExisting();
			}
			catch (Exception) { return; }
			if (tmp.Length == 0) { return; }
			
			//Put Code here to Handle Received Serial Data
			SerialComScript.Dbg(" " + tmp);
		}		
	}
}
